package domain;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Trade implements Comparable<Trade> {

	/*
	[transactionId] [varchar](50) NOT NULL,
	[status] [varchar](50) NULL,
	[transactionTime] [varchar](50) NULL,
	[side] [varchar](50) NULL,
	[totalQuantity] [varchar](50) NULL,
	[lastQuantity] [varchar](50) NULL,
	[leavesQuantity] [varchar](50) NULL,
	[orderQuantity] [varchar](50) NULL,
	[cashAmount] [varchar](50) NULL,
	[price] [varchar](50) NULL,
	[chargeRate] [varchar](50) NULL,
	[settlementDate] [varchar](50) NULL,
	[executionId] [varchar](50) NULL,
	[currency] [varchar](50) NULL,
	[accruedInterest] [varchar](50) NULL,
	[settlementCurrency] [varchar](50) NULL,
	[settlementCurrencyExchangeRateBasis] [varchar](50) NULL,
	[settlementCurrencyExchangeRate] [varchar](50) NULL,
	[executionType] [varchar](50) NULL,
	[secondaryExecutionId] [varchar](50) NULL,
	[executionVenue] [varchar](50) NULL,	
	[senderCompanyId] [varchar](50) NULL,
	[sequenceNumber] [varchar](50) NULL,
	[securityId] [varchar](50) NULL,
	[symbol] [varchar](50) NULL,
	[securityType] [varchar](50) NULL,
	[actionStatus] [varchar](50) NULL,
	[creationDate] [datetime] NULL,
	[modifieddate] [datetime] NULL,
	[creationByUser] [varchar](50) NULL,
	[modifiedByUser] [varchar](50) NULL,
	 */
	private Integer transactionId;
	private String dateString;
	private String status;
	private Date transactionTime;
	private String transactionTimeStr;
	private String side;
	private Integer totalQuantity;
	private Integer lastQuantity;
	private Integer leavesQuantity;
	private Integer orderQuantity;
	private Double cashAmount;
	private Double price;
	private Double chargeRate;
	private Date settlementDate;
	private Integer executionId;
	private String currency;
	private Double accruedInterest;
	private String settlementCurrency;
	private Double settlementCurrencyExchangeRateBasis;
	private Double settlementCurrencyExchangeRate;
	private String executionType;
	private Integer secondaryExecutionId;
	private String executionVenue;
	private Integer senderCompanyId;
	private Integer sequenceNumber;
	private String securityId;
	private String symbol;
	private String securityType;
	private String actionStatus;
	private Date createDate;
	private Date modifiedDate;
	private String creationByUser;
	private String modifiedByUser;
	
	
	public Trade()
	{
		
	}
			
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((transactionId == null) ? 0 : transactionId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof Trade))
			return false;
		Trade other = (Trade) obj;
		if (transactionId == null) {
			if (other.transactionId != null)
				return false;
		} else if (!transactionId.equals(other.transactionId))
			return false;
		return true;
	}

	public String getDateString() {
		return dateString;
	}

	public void setDateString(String dateString) {
		this.dateString = dateString;
	}

	
	public Integer getTransactionId() {
		return transactionId;
	}
	public void setTransactionId(Integer orderId) {
		this.transactionId = orderId;
	}

	
	public String getStatus() {
		return status;
	}


	public void setStatus(String status) {
		this.status = status;
	}


	public Date getTransactionTime() {
		return transactionTime;
	}


	public void setTransactionTime(Date transactionTime) {
		this.transactionTime = transactionTime;
	}

	

	public String getTransactionTimeStr() {
		return transactionTimeStr;
	}


	public void setTransactionTimeStr(String transactionTimeStr)  {
		this.transactionTimeStr = transactionTimeStr;
		try {
			transactionTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").parse(transactionTimeStr);
			// TODO Change this dummy
			createDate = transactionTime;
		} catch (ParseException e) {

			e.printStackTrace();
		}
	}


	public String getSide() {
		return side;
	}


	public void setSide(String side) {
		this.side = side;
	}


	public Integer getTotalQuantity() {
		return totalQuantity;
	}


	public void setTotalQuantity(Integer totalQuantity) {
		this.totalQuantity = totalQuantity;
	}


	public Integer getLastQuantity() {
		return lastQuantity;
	}


	public void setLastQuantity(Integer lastQuantity) {
		this.lastQuantity = lastQuantity;
	}


	public Integer getLeavesQuantity() {
		return leavesQuantity;
	}


	public void setLeavesQuantity(Integer leavesQuantity) {
		this.leavesQuantity = leavesQuantity;
	}


	public Integer getOrderQuantity() {
		return orderQuantity;
	}


	public void setOrderQuantity(Integer orderQuantity) {
		this.orderQuantity = orderQuantity;
	}


	public Double getCashAmount() {
		return cashAmount;
	}


	public void setCashAmount(Double cashAmount) {
		this.cashAmount = cashAmount;
	}


	public Double getPrice() {
		return price;
	}


	public void setPrice(Double price) {
		this.price = price;
	}


	public Double getChargeRate() {
		return chargeRate;
	}


	public void setChargeRate(Double chargeRate) {
		this.chargeRate = chargeRate;
	}


	public Date getSettlementDate() {
		return settlementDate;
	}


	public void setSettlementDate(Date settlementDate) {
		this.settlementDate = settlementDate;
	}


	public Integer getExecutionId() {
		return executionId;
	}


	public void setExecutionId(Integer executionId) {
		this.executionId = executionId;
	}


	public String getCurrency() {
		return currency;
	}


	public void setCurrency(String currency) {
		this.currency = currency;
	}


	public Double getAccruedInterest() {
		return accruedInterest;
	}


	public void setAccruedInterest(Double accruedInterest) {
		this.accruedInterest = accruedInterest;
	}


	public String getSettlementCurrency() {
		return settlementCurrency;
	}


	public void setSettlementCurrency(String settlementCurrency) {
		this.settlementCurrency = settlementCurrency;
	}


	public Double getSettlementCurrencyExchangeRateBasis() {
		return settlementCurrencyExchangeRateBasis;
	}


	public void setSettlementCurrencyExchangeRateBasis(
			Double settlementCurrencyExchangeRateBasis) {
		this.settlementCurrencyExchangeRateBasis = settlementCurrencyExchangeRateBasis;
	}


	public Double getSettlementCurrencyExchangeRate() {
		return settlementCurrencyExchangeRate;
	}


	public void setSettlementCurrencyExchangeRate(
			Double settlementCurrencyExchangeRate) {
		this.settlementCurrencyExchangeRate = settlementCurrencyExchangeRate;
	}


	public String getExecutionType() {
		return executionType;
	}


	public void setExecutionType(String executionType) {
		this.executionType = executionType;
	}


	public Integer getSecondaryExecutionId() {
		return secondaryExecutionId;
	}


	public void setSecondaryExecutionId(Integer secondaryExecutionId) {
		this.secondaryExecutionId = secondaryExecutionId;
	}


	public String getExecutionVenue() {
		return executionVenue;
	}


	public void setExecutionVenue(String executionVenue) {
		this.executionVenue = executionVenue;
	}


	public Integer getSenderCompanyId() {
		return senderCompanyId;
	}


	public void setSenderCompanyId(Integer senderCompanyId) {
		this.senderCompanyId = senderCompanyId;
	}


	public Integer getSequenceNumber() {
		return sequenceNumber;
	}


	public void setSequenceNumber(Integer sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}


	public String getSecurityId() {
		return securityId;
	}


	public void setSecurityId(String securityId) {
		this.securityId = securityId;
	}


	public String getSymbol() {
		return symbol;
	}


	public void setSymbol(String symbol) {
		this.symbol = symbol;
	}


	public String getSecurityType() {
		return securityType;
	}


	public void setSecurityType(String securityType) {
		this.securityType = securityType;
	}


	public String getActionStatus() {
		return actionStatus;
	}


	public void setActionStatus(String actionStatus) {
		this.actionStatus = actionStatus;
	}


	public Date getCreateDate() {
		return createDate;
	}


	public void setCreateDate(Date createDate) {
		this.createDate = createDate;
	}


	public Date getModifiedDate() {
		return modifiedDate;
	}


	public void setModifiedDate(Date modifiedDate) {
		this.modifiedDate = modifiedDate;
	}


	public String getCreationByUser() {
		return creationByUser;
	}


	public void setCreationByUser(String creationByUser) {
		this.creationByUser = creationByUser;
	}


	public String getModifiedByUser() {
		return modifiedByUser;
	}


	public void setModifiedByUser(String modifiedByUser) {
		this.modifiedByUser = modifiedByUser;
	}


	@Override
	public int compareTo(Trade o) {

		if (o == null)
			return -1;
		
		return transactionId.compareTo(o.transactionId);
	}

	@Override
	public String toString() {
		
		StringBuffer sb = new StringBuffer();
		sb.append("Trade {");
		sb.append(" transactionId=").append(transactionId).append(';');
		
		sb.append("}");
		return sb.toString();
	}

	
	
}
