package domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TradeSearchParams {

	private Date fromDate;
	private Date toDate;
	private List<String> securityTypes = new ArrayList<String>();
	private boolean buy;
	private boolean sell;
	private String tidmText;
	private List<String> selectedTIDMs = new ArrayList();
	private List<String> TIDMs = new ArrayList<String>();
	
	
	
	public TradeSearchParams() {
		setupTIDMs();
	}

	public List<String> tidmAutocomplete(Object suggest) {
	        String pref = (String)suggest;
	        ArrayList<String> result = new ArrayList<String>();

	        Iterator<String> iterator = getTIDMs().iterator();
	        while (iterator.hasNext()) {
	        	String elem = ((String) iterator.next());
	            if ((elem!= null && elem.toLowerCase().indexOf(pref.toLowerCase()) == 0) || "".equals(pref))
	            {
	                result.add(elem);
	            }
	        }
	        return result;
	    }
	
	public Date getFromDate() {
		return fromDate;
	}
	public void setFromDate(Date fromDate) {
		this.fromDate = fromDate;
	}
	public Date getToDate() {
		return toDate;
	}
	public void setToDate(Date toDate) {
		this.toDate = toDate;
	}
	public List<String> getSecurityTypes() {
		return securityTypes;
	}
	public void setSecurityTypes(List<String> securityTypes) {
		this.securityTypes = securityTypes;
	}
	public boolean isBuy() {
		return buy;
	}
	public void setBuy(boolean buy) {
		this.buy = buy;
	}
	public boolean isSell() {
		return sell;
	}
	public void setSell(boolean sell) {
		this.sell = sell;
	}

	public String getTidmText() {
		return tidmText;
	}

	public void setTidmText(String tidmText) {
		this.tidmText = tidmText;
		selectedTIDMs.clear();
		if (tidmText != null && tidmText.length() > 0)
		{
			String [] tidmStrings = tidmText.split(",");
			for (String s : tidmStrings)
			{
				if (s != null && s.length() > 0)
					selectedTIDMs.add(s.trim());				
			}
		}
		

	}
		
	public List<String> getTIDMs() {
		return TIDMs;
	}

	public void setTIDMs(List<String> ms) {
		TIDMs = ms;
	}

	public List<String> getSelectedTIDMs() {
		return selectedTIDMs;
	}

	public void setSelectedTIDMs(List<String> selectedTIDMs) {
		this.selectedTIDMs = selectedTIDMs;
	}

	public boolean isTIDMMatch(String tidm)
	{
		return (selectedTIDMs.contains(tidm));
		
	}
	
	private void setupTIDMs()
	{
		TIDMs.add("ZATST");
		TIDMs.add("SAT");
		TIDMs.add("ZULVR");
		TIDMs.add("ZCKSN");
		TIDMs.add("ZRTR");
		TIDMs.add("PRU");
		TIDMs.add("BP.");
		TIDMs.add("ICI");
		TIDMs.add("ALLD");
		TIDMs.add("ZLAD");
		TIDMs.add("RIO");
		TIDMs.add("BNZL");
		TIDMs.add("BT.A");
		TIDMs.add("EMI");
		TIDMs.add("SBRY");
		TIDMs.add("LAND");
		TIDMs.add("HNS");
		TIDMs.add("SHEL");
		TIDMs.add("KGF");
		TIDMs.add("BARC");
		TIDMs.add("NXT");
		TIDMs.add("ZWTB");
		TIDMs.add("BOOX");
		TIDMs.add("RBS");
		TIDMs.add("PILK");
		TIDMs.add("CW.");
		TIDMs.add("UNIQ");
		TIDMs.add("PSON");
		TIDMs.add("STAN");
		TIDMs.add("ZCBRY");
		TIDMs.add("ZRNK");
		TIDMs.add("BOC");
		TIDMs.add("ABF");
		TIDMs.add("GUS");
		TIDMs.add("SN.");
		TIDMs.add("BPB");
		TIDMs.add("ZRB.");
		TIDMs.add("AV.");
		TIDMs.add("RSA");
		TIDMs.add("LGEN");
		TIDMs.add("BA.");
		TIDMs.add("PO.");
		TIDMs.add("DGE");
		TIDMs.add("DSGI");
		TIDMs.add("GKN");
		TIDMs.add("RMC");
		TIDMs.add("MTC");
		TIDMs.add("LLOY");
		TIDMs.add("SCTN");
		TIDMs.add("WMPY");
		TIDMs.add("BBY");
		TIDMs.add("ENO");
		TIDMs.add("NFDS");
		TIDMs.add("TATE");
		TIDMs.add("TSCO");
		TIDMs.add("FKI");
		TIDMs.add("RR.");
		TIDMs.add("ZSMIN");
		TIDMs.add("ZAGA");
		TIDMs.add("IMI");
		TIDMs.add("BG.");
		TIDMs.add("HMSO");
		TIDMs.add("ZUBM");
		TIDMs.add("BAA");
		TIDMs.add("BAY");
		TIDMs.add("ZINCH");
		TIDMs.add("THRG");
		TIDMs.add("CTY");
		TIDMs.add("BAB");
		TIDMs.add("DVR");
		TIDMs.add("ZHYWD");
		TIDMs.add("BVIT");
		TIDMs.add("NVR");
		TIDMs.add("AMEC");
		TIDMs.add("TW.");
		TIDMs.add("IRV");
		TIDMs.add("ZVOD");
		TIDMs.add("ZPFG");
		TIDMs.add("SVC");
		TIDMs.add("GET");
		TIDMs.add("ZISYS");
		TIDMs.add("ELM");
		TIDMs.add("LWB");
		TIDMs.add("BLND");
		TIDMs.add("MKLW");
		TIDMs.add("ZSGRO");
		TIDMs.add("ZEMA");
		TIDMs.add("ZSMWH");
		TIDMs.add("ZAXN");
		TIDMs.add("DWSN");
		TIDMs.add("ZCPL");
		TIDMs.add("AWG");
		TIDMs.add("ZUU.");
		TIDMs.add("ZSVT");
		TIDMs.add("PNNX");
		TIDMs.add("ZKEL");
		TIDMs.add("IPR");
		TIDMs.add("SSE");
		TIDMs.add("ZSPW");
		TIDMs.add("TOMKGB0000183045");
	}
	
	
}
