package filter;


import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;

import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.Enumeration;
import java.util.logging.Logger;

/**
 * @author jon_m
 * 
 */
public class AccessFilter implements Filter {
    private Logger log = Logger.getLogger("filter.AccessFilter");

    public void init(FilterConfig filterConfig) throws ServletException {

    }

    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse,
                         FilterChain filterChain) throws IOException, ServletException {
        HttpServletRequest httpServletRequest = (HttpServletRequest) servletRequest;
        HttpSession session = httpServletRequest.getSession();

        Enumeration names = httpServletRequest.getAttributeNames();
        while (names.hasMoreElements()) {
            String name = (String) names.nextElement();
            Object value = httpServletRequest.getAttribute(name);
            log.info("Attribute ["+name+"] = ["+value+"]");
        }
        
        names = httpServletRequest.getHeaderNames();
        while (names.hasMoreElements()) {
            String name = (String) names.nextElement();
            String value = httpServletRequest.getHeader(name);
            log.info("Header ["+name+"] = ["+value+"]");
        }

        Thread.currentThread().setName(servletRequest.getRemoteAddr() + "::" + httpServletRequest.getRequestURI());
        log.info("AccessFilter: " + servletRequest.getRemoteAddr());

        
        Enumeration parameterNames = httpServletRequest.getParameterNames();
        log.info("Params count" + httpServletRequest.getParameterMap().size());

        while (parameterNames.hasMoreElements()) {
            Object o = parameterNames.nextElement();
            log.info("Param name: " + o);
        }

        log.info("Session: " + session.getId());

        
        filterChain.doFilter(servletRequest, servletResponse);
    }

    public void destroy() {

    }
}
