package model;


import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;

import javax.faces.FacesException;

import org.apache.commons.digester.Digester;
import org.apache.commons.digester.xmlrules.DigesterLoader;
import org.xml.sax.SAXException;

import domain.Trade;

public class TradeBean {
	private ArrayList<Trade> trades = new ArrayList<Trade>();
	 
       
	public TradeBean() {
		URL rulesUrl = getClass().getResource("trades-rules.xml");
		Digester digester =	DigesterLoader.createDigester(rulesUrl);
		digester.push(this);
		try {
			digester.parse(getClass().getResourceAsStream("trades.xml"));
		} catch (IOException e) {
			throw new FacesException(e);
		} catch (SAXException e) {
			throw new FacesException(e);
		}
		
	}
		
	public void addTrade(Trade trade)
	{
		trades.add(trade);
	}
	
	public ArrayList<Trade> getTrades() {
		return trades;
	}
	
}
